﻿using System;
using ff14bot.Behavior;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using RetBot.Settings;
using TreeSharp;

namespace RetBot
{
    public class RetBot : IBotPlugin
    {
        #region Identity Information
        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }

        public string Author
        {
            get { return " newb23"; }
        }

        public string Description
        {
            get { return " Retainer Auto-Quick Explorer"; }
        }

        public Version Version
        {
            get { return new Version( 2, 0, 6); }
        }

        public string Name
        {
            get { return " RetBot"; }
        }

        public void OnInitialize()
        {
            
        }


        public void OnEnabled()
        {            
                Logging.Write("[RetBot] Enabled");
                GamelogManager.MessageRecevied += MessageReceived;
                TreeHooks.Instance.OnHooksCleared += OnHooksCleared;
                RetBotLoop = 1;
                _root = new ActionRunCoroutine(r => MovementActions.RetainerMove());
        }

        public void OnShutdown()
        {
            RetBotLoop = 0;
            GamelogManager.MessageRecevied -= MessageReceived;
            TreeHooks.Instance.OnHooksCleared -= OnHooksCleared;
            RemoveHook();
        }

        public void OnDisabled()
        {
            Logging.Write("[RetBot] Disabled");
            RetBotLoop = 0;
            GamelogManager.MessageRecevied -= MessageReceived;
            TreeHooks.Instance.OnHooksCleared -= OnHooksCleared;
            RemoveHook();
        }

        private void OnHooksCleared(object sender, EventArgs args)
        {
            AddHook();
        }

        public void AddHook()
        {
            TreeHooks.Instance.AddHook("TreeStart", _root);
        }

        public void RemoveHook()
        {
            TreeHooks.Instance.RemoveHook("TreeStart", _root);
        }

        public bool WantButton
        {
            get { return true; }
        }

        public string ButtonText
        {
            get { return "RetBot"; }
        }

        public void OnButtonPress()
        {
            if (_form == null || _form.IsDisposed || _form.Disposing)
                _form = new RetBot_Form();

            _form.ShowDialog();
        }
        #endregion

        public void OnPulse()
        {            

        }
        
        
        //Variables / Declarations
        private RetBot_Form _form;
        public static RetBotSettings settings = RetBotSettings.instance;
        private Composite _root;
        public static int RetBotLoop;


        public static void MessageReceived(object sender, ChatEventArgs e)
        {
            if (e.ChatLogEntry.Contents.Contains(settings.Lan_V_Complete))
            {
                RetBotLoop = 1;
            }
        }
        //All code in Main plugin class must go above this line.
    }
}
