﻿using System.Diagnostics;
using System.Threading.Tasks;
using Buddy.Coroutines;
using Clio.Utilities;
using ff14bot;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Objects;
using ff14bot.RemoteWindows;
using RetBot.Settings;

namespace RetBot
{
    public class RetainerRetask
    {
        //Variables / Declarations
        private static GameObject _summonbell;
        public static int LoopCount;
        public static int RetRetn;
        private RetBot_Form _form;
        public static RetBotSettings settings = RetBotSettings.instance;
        


        public static async Task Retask()
        {          
            var location = new Vector3(36.32549f, 28.99997f, -762.0803f);
            var stopwatch = new Stopwatch();

            stopwatch.Start();
            while (stopwatch.ElapsedMilliseconds > 60000)
            {
                Logging.Write("[Retbot] Took too long to complete reassignment! Restarting!");
                stopwatch.Reset();
                Talk.Next();
                await Retask();
            }
            
            while (Core.Player.Distance(location) > 3)
            {
                await Coroutine.Sleep(1000);
            }
            _summonbell = GameObjectManager.GetObjectByObjectId(4627756);


            while (LoopCount < 4 && RetRetn == 0)
            {
                #region Retainer Selection
                //Open retainer list
                Logging.Write("[Retbot] Stopwatch at " + stopwatch.ElapsedMilliseconds + "!");                
                Logging.Write("[Retbot] Using Summoning Bell.");
                await Coroutine.Sleep(1000);
                _summonbell.Interact();
                await Coroutine.Sleep(1000);

                //Select A Retainer
                Logging.Write("[Retbot] Searching for Complete Ventures.");
                while (!SelectString.IsOpen)
                    await Coroutine.Sleep(1000);                
                    {
                        if (SelectString.ClickLineContains(settings.Lan_Complete))
                        {
                            Logging.Write("[Retbot] Selecting first available Retainer.");
                            await Coroutine.Sleep(3000);
                        }

                        else
                        {
                            Logging.Write("[Retbot] No Ventures available, Quitting Retainer Menu.");
                            SelectString.ClickLineContains(settings.Lan_Quit);
                            await Coroutine.Sleep(1000);
                            RetRetn = 0;
                            LoopCount = 0;
                            return;
                        }
                    }

                    //Skip dialog
                while (!Talk.DialogOpen)
                    await Coroutine.Sleep(1000);
                Talk.Next();
                await Coroutine.Sleep(1000);
                #endregion 

                //View Venture Report
                Logging.Write("[Retbot] Selecting Venture Report.");
                while (!SelectString.IsOpen)
                    await Coroutine.Sleep(1000);
                SelectString.ClickSlot(5);
                await Coroutine.Sleep(1000);

                //Venture Report Window Reassign/Confirm
                Logging.Write("[Retbot] Reassigning Venture.");
                while (!RetainerTaskResult.IsOpen)
                    await Coroutine.Sleep(1000);
                RetainerTaskResult.Reassign();
                    await Coroutine.Sleep(1000);

                //Venture Confirm Window
                Logging.Write("[Retbot] Confirming Reassignment.");
                while (!RetainerTaskAsk.IsOpen)
                    await Coroutine.Sleep(2000);
                RetainerTaskAsk.Confirm();
                    await Coroutine.Sleep(1000);

                //Wait/Skip dialog
                while (!Talk.DialogOpen)
                    await Coroutine.Sleep(1000);
                Talk.Next();
                    await Coroutine.Sleep(1000);

                //Quit Retainer Dialog
                Logging.Write("[Retbot] Quitting Selected Retainer.");
                while (!SelectString.IsOpen)
                    await Coroutine.Sleep(1000);
                SelectString.ClickSlot(10);
                    await Coroutine.Sleep(1000);

                //Wait/Skip dialog
                while (!Talk.DialogOpen)
                    await Coroutine.Sleep(1000);
                Talk.Next();
                    await Coroutine.Sleep(1000);

                //None of the Retainers are back/ready
                Logging.Write("[Retbot] Quitting Retainer Menu.");
                SelectString.ClickLineContains(settings.Lan_Quit);
                    await Coroutine.Sleep(1000);

                Logging.Write("[Retbot] Returning to Beginning.");
                    await Coroutine.Sleep(1000);

                RetRetn = 0;
                LoopCount++;

            }
            stopwatch.Stop();
            Logging.Write("[Retbot] All avilable ventures ordered!");
            LoopCount = 0;
        }
    }
}
